#!/bin/sh

get_section_offset()
{
    echo 0x`readelf -SW "$1" | grep " $2" | sed -e 's/\[ */\[/' | awk '{print $5}'`
}

get_symbol_offset()
{
    echo 0x`readelf -sW "$1" | grep "[0-9] $2$" | awk '{print $2}'`
}

get_symbol_num()
{
    readelf -sW "$1" | grep "LOCAL.* $2$" | sed -e 's/:.*//'
}

get_file_offset()
{
    sec=`get_section_offset $1 $2`
    sym=`get_symbol_offset $1 $3`
    echo $(($sec + $sym))
}

global_symbol()
{
    num=`get_symbol_num $1 $2`
    sec=`get_section_offset $1 ".symtab"`
    off=$(($sec + $num * 0x10 + 0xc))

    printf "sec:%x num:%x off:%x\n" $sec $num $off
    perl -e "print pack('c', 0x12);" | dd of=$1 bs=1 seek=$off count=1 conv=notrunc 2> /dev/null
}





# for DEBUG

# global_symbol $1 "pxa_sd_get_response_value"

# #Hook busctrl->pxa_sd_get_response_value

# func=`get_symbol_offset $1 "pxa_sd_get_response_value_mod"`
# ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 40))
# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null



# global_symbol $1 "sd_write_single_block_withcheck"
# global_symbol $1 "sd_read_single_block_withcheck"

# # Hook sd_control->sd_read_single_block_withcheck

# func=`get_symbol_offset $1 "sd_read_single_block_withcheck_mod"`
# ptr=$((`get_file_offset $1 ".data" "sd_control"` + 0))

# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# # Hook sd_control->sd_write_single_block_withcheck

# func=`get_symbol_offset $1 "sd_write_single_block_withcheck_mod"`
# ptr=$((`get_file_offset $1 ".data" "sd_control"` + 4))

# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null





# globalize symbols

global_symbol $1 "pxa_sd_put_command"
global_symbol $1 "pxa_sd_opendrain_command"

# Hook busctrl->pxa_sd_put_command

func=`get_symbol_offset $1 "pxa_sd_put_command_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 24))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook busctrl->pxa_sd_opendrain_command

func=`get_symbol_offset $1 "pxa_sd_put_command_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 28))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Hook calling sd_idle_card_present_sd in sd_idle_card_presend()

func=$((`get_symbol_offset $1 "sd_idle_card_present_sd_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_idle_card_present"` + 0x38))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Modify switch() table to support CMD8

func=$((`get_symbol_offset $1 "pxa_sd_put_command"`))
ptr=$((`get_file_offset $1 ".text" "pxa_sd_put_command"` + 0xb4))

cmd=$(($func + 0x200))
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Hook calling sd_get_csd in sd_detect_insert()

func=$((`get_symbol_offset $1 "sd_get_csd_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x62b4 - 0x61a0))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Hook calling get_cluster_size in sd_detect_insert()

func=$((`get_symbol_offset $1 "get_cluster_size_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x6334 - 0x61a0))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null





# Patch total_size/512 in sd_detect_insert()

ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x6320 - 0x61a0))
cmd0=0xe080000c   # add r0, r0, ip
cmd1=0xe2400007   # sub r0, r0, #7
cmd2=0xe1a03013   # mov r3, r3, lsl r0
printf "cmd:%x %x %x ptr:%x\n" $cmd0 $cmd1 $cmd2 $ptr
perl -e "print pack('III', $cmd0, $cmd1, $cmd2);" | dd of=$1 bs=1 seek=$ptr count=12 conv=notrunc 2> /dev/null

#exit;

# Patch total_size/512 in setup_partition_table()

ptr=$((`get_file_offset $1 ".text" "setup_partition_table"` + 0x175c - 0x171c))
cmd=0xe1a030a3   # mov r3, r3, lsr #1
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "setup_partition_table"` + 0x177c - 0x171c))
cmd=0xe1a00000   # nop
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Patch total_size/512 in mmcd_revalidate()

ptr=$((`get_file_offset $1 ".text" "mmcd_revalidate"` + 0x1f98 - 0x1e3c))
cmd=0xe1a020a3   # mov r2, r3, lsr #1
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "mmcd_revalidate"` + 0x1fa8 - 0x1e3c))
cmd=0xe1a00000   # nop
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

#exit

# Patch pos/512 in mmcd_request()

ptr=$((`get_file_offset $1 ".text" "mmcd_request"` + 0x21c4 - 0x1fd8))
cmd0=0xe1a05002   # mov r5, r2
cmd1=0xe1a00000   # nop
printf "cmd:%x %x ptr:%x\n" $cmd0 $cmd1 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null


# Patch skip pos check in sd_read_single_block_withcheck()

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x3f54 - 0x3efc))
cmd0=0xe3a00000   # mov r0, #0
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x3f5c - 0x3efc))
cmd0=0xe598a084   # ldr sl, [r8, #132]
cmd1=0x1a000fd7   # bne 3f64
printf "cmd:%x %x ptr:%x\n" $cmd0 $cmd1 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x3f68 - 0x3efc))
cmd0=0xe3a00000   # mov r0, #0
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x3fd4 - 0x3efc))
cmd0=0xe1a014aa   # mov r1, sl
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x3ff4 - 0x3efc))
cmd0=0xe3510010   # cmp r1, #8192/512
cmd1=0x90803001   # addls r3, r0, r1
cmd2=0x82803010   # addhi r3, r0, #(8192 / 512)
printf "cmd:%x %x %x ptr:%x\n" $cmd0 $cmd1 $cmd2 $ptr
perl -e "print pack('III', $cmd0, $cmd1, $cmd2);" | dd of=$1 bs=1 seek=$ptr count=12 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x400c - 0x3efc))
cmd0=0xe3510010   # cmp r1, #8192/512
cmd1=0x23a01010   # movcs r1, #(8192 / 512)
printf "cmd:%x %x ptr:%x\n" $cmd0 $cmd1 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x4038 - 0x3efc))
cmd0=0x31a044a3   # movcc r4, r3, lsr #9
cmd1=0x23a04010   # movcs r4, #(8192 / 512)
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x4070 - 0x3efc))
cmd0=0xe3a01001   # mov r1, #1
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x40dc - 0x3efc))
cmd0=0xe0821481   # add r1, r2, r1, lsl #9
cmd1=0xe1a02486   # mov r2, r6, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x412c - 0x3efc))
cmd0=0xe1b06486   # movs r6, r6, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x4164 - 0x3efc))
cmd0=0xe08774a4   # add r7, r7, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null



# Patch skip pos check in sd_write_single_block_withcheck()

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4594 - 0x4564))
cmd0=0xe3a0a001   # mov sl, #1
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x46a4 - 0x4564))
cmd0=0xe1a014a4   # mov r1, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x46ac - 0x4564))
cmd0=0xe06004a4   # rsb r0, r0, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x473c - 0x4564))
cmd0=0xe1a014a4   # mov r1, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4748 - 0x4564))
cmd0=0xe06004a4   # rsb r0, r0, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4768 - 0x4564))
cmd0=0xe1a02487   # mov r2, r7, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4774 - 0x4564))
cmd0=0xe0830480   # add r0, r3, r0, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4810 - 0x4564))
cmd0=0xe1a02487   # mov r2, r7, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4818 - 0x4564))
cmd0=0xe083048c   # add r0, r3, ip, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x48c4 - 0x4564))
cmd0=0xe1a0348a   # mov r3, sl, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x494c - 0x4564))
cmd0=0xe3a03001   # mov r3, sl, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4960 - 0x4564))
cmd0=0xe1a03484   # mov r3, r4, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x4974 - 0x4564))
cmd0=0xe0866484   # add r6, r6, r4, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null




# Patch skip pos check in sd_write_single_block_withcheck()

ptr=$((`get_file_offset $1 ".text" "sd_flush_internal_w_buffer"` + 0x4b8c - 0x4994))
cmd0=0xe08774a4   # add r7, r7, r4 lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# reduce MMC number of trials

ptr=$((`get_file_offset $1 ".text" "sd_idle_card_present_mmc"` + 0x2f9c - 0x2f04))
cmd0=0xe355000a   # cmp r5, #10
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null






# Hook busctrl->pxa_sd_receive_chars

global_symbol $1 "pxa_sd_receive_chars"

func=`get_symbol_offset $1 "pxa_sd_receive_chars_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 48))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null
